/******************************************************************************
 *
 * Simple web client (c) 1999 Eugen Kuleshov
 *
 *****************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <netdb.h>
#include <arpa\inet.h>


void main(int argc, char **argv) {
  struct sockaddr_in server;
  struct hostent *hp;
  char req[ 8192];
  char buf[ 8192];
  struct servent *echoprot;
  int sock, len, rc;

  // Initialize TCP/IP
  if( sock_init()!=0) {
    printf( "INET.SYS probably is not running");
    exit( 1);
  }

  // Check to make sure the user passed the right number of arguments
  if( argc!=3 || argc>1 && argv[ 1][ 0]=='?') {
    printf( "Usage: webclnt <host> <document>\n"
            "\t<host>     Specifies the web server host.\n"
            "\t<document> Specifies document for get.\n");
    exit( 1);
  }

  // Open the correct type of socket
  sock = socket( AF_INET, SOCK_STREAM, 0);
  if( sock==-1) {
    psock_errno( "socket()");
    exit( 1);
  }

  // Set the server address from argument 1 -- we accept both domain names
  // and IP addresses
  server.sin_addr.s_addr = inet_addr( argv[ 1]);
  if( server.sin_addr.s_addr==-1) {
    // It wasn't a dotted decimal address -- assume it's a domain name,
    // and use gethostbyname() to convert it
    hp = gethostbyname( argv[ 1]);
    if( hp) {
      server.sin_family = hp->h_addrtype;
      memcpy( &server.sin_addr, hp->h_addr, sizeof( server.sin_addr));
    } else {
      printf( "Unknown host %s\n", argv[ 1]);
      exit( 1);
    }
  }

  // Get the port for the echo protocol out of the etc\services file
  echoprot = getservbyname( "www", "tcp");
  if( echoprot==NULL) {
     printf( "The www/tcp protocol is not listed in the etc/services file\n", argv[ 1]);
     exit(1);
  }

  // Set the rest of the server address
  server.sin_family = AF_INET;
  server.sin_port = echoprot->s_port;

  // Connect to the server
  rc = connect( sock, ( struct sockaddr *) &server, sizeof( server));
  if( rc==-1) {
    psock_errno( "connect()");
    exit( 1);
  }

  //  
  //  
  strcpy( req, "GET ");
  //  
  strcat( req, argv[ 2]);
  //  ,  
  strcat( req, " HTTP/1.0\n");
  //   
  strcat( req, "User-Agent: Simple Web client by Eugen Kuleshov\n");
  strcat( req, "Accept: */*\n");
  //  
  strcat( req, "\n\n"); 

  //    
  rc = send( sock, req, strlen( req), 0);
  if( rc==-1) {
    psock_errno( "send()");
    exit( 1);
  }

  //      
  do {
    len = recv( sock, buf, sizeof( buf), 0);
    if( len==-1) {
      psock_errno( "recv()");
      exit( 1);
    }
    buf[ len] = '\0';
    printf( "%s", buf);
  } while( len!=0);
  printf( "\n\n");

}

